import 'package:atomic_state/atomic_state.dart';

class Counter extends State {
  static String name = 'counter';
  final int count;

  Counter({
    this.count = 0
  });
  factory Counter.from(Counter counter, {int count}) => Counter(count: count ?? counter.count);

  Counter inc([int value = 1]) => Counter.from(this, count: count + value);

  @override
  Map<String, dynamic> toJson() => {
    'count': count
  };
}